VERSION 5.00
Object = "{EAB22AC0-30C1-11CF-A7EB-0000C05BAE0B}#1.1#0"; "shdocvw.dll"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   ClientHeight    =   10440
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   12225
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   696
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   815
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command1 
      Caption         =   "&Start with patchfile:"
      Height          =   435
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   1875
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   2160
      Style           =   2  'Dropdown-Liste
      TabIndex        =   3
      Top             =   180
      Width           =   5055
   End
   Begin VB.TextBox Text1 
      Height          =   9675
      Left            =   12300
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Beides
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   660
      Width           =   12135
   End
   Begin VB.TextBox Text2 
      Height          =   1095
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   1
      Top             =   9240
      Width           =   12000
   End
   Begin SHDocVwCtl.WebBrowser WebBrowser1 
      Height          =   8475
      Left            =   120
      TabIndex        =   0
      Top             =   660
      Width           =   12000
      ExtentX         =   21167
      ExtentY         =   14949
      ViewMode        =   0
      Offline         =   0
      Silent          =   0
      RegisterAsBrowser=   0
      RegisterAsDropTarget=   1
      AutoArrange     =   0   'False
      NoClientEdge    =   0   'False
      AlignLeft       =   0   'False
      NoWebView       =   0   'False
      HideFileNames   =   0   'False
      SingleClick     =   0   'False
      SingleSelection =   0   'False
      NoFolders       =   0   'False
      Transparent     =   0   'False
      ViewID          =   "{0057D0E0-3573-11CF-AE69-08002B2E1262}"
      Location        =   ""
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetPrivateProfileString Lib "kernel32" _
  Alias "GetPrivateProfileStringA" ( _
  ByVal lpApplicationName As String, _
  ByVal lpKeyName As Any, _
  ByVal lpDefault As String, _
  ByVal lpReturnedString As String, _
  ByVal nSize As Long, _
  ByVal lpFileName As String) As Long

Dim sIP As String
Const lMax As Long = 20
Dim sURLs(1 To lMax) As String
Dim sFrames(1 To lMax) As String
Dim sLibraryFiles() As String
Dim sLibraryContent() As String

Public Sub Command1_Click()
    Dim sLog As String
    Dim sIniTmp As String
    
    Dim sIniFile As String
    sIniFile = App.Path & "\" & Combo1.List(Combo1.ListIndex)
    
    sIP = GetIniString(App.Title, "IP", "https://speedport.ip", sIniFile)
    Do_Log "Read param, IP: " & sIP
    
    Erase sURLs
    Erase sFrames

    Dim i As Long
    For i = 1 To lMax
        sIniTmp = GetIniString(App.Title, "URL" & i, "", sIniFile)
        If sIniTmp <> "" Then
            Dim sTmpA() As String
            sTmpA = Split(sIniTmp, ",")
            sURLs(i) = Trim(sTmpA(0))
            sLog = sURLs(i)
            If UBound(sTmpA) > 0 Then
                sFrames(i) = Trim(sTmpA(1))
                sLog = sLog & " in frame: " & sFrames(i)
            Else
                sLog = sLog & " in top window"
            End If
            Do_Log "Read param, URL" & i & ": " & sLog
        End If
    Next
    
    Erase sLibraryFiles
    Erase sLibraryContent
    
    sIniTmp = GetIniString(App.Title, "LIBRARIES", "", sIniFile)
    If sIniTmp <> "" Then
        sLibraryFiles = Split(sIniTmp, ",")
        ReDim sLibraryContent(UBound(sLibraryFiles))
        Dim sTmp As String
        For i = LBound(sLibraryFiles) To UBound(sLibraryFiles)
            sTmp = Read_File(Trim(sLibraryFiles(i)))
            If sTmp = "" Then
                MsgBox "File not found/empty: " & sLibraryFiles(i) & vbCrLf & vbCrLf & "The patchfile requires this library!", vbCritical
            Else
                sLibraryContent(i) = sTmp
            End If
        Next
    End If
    
    Read_Patch
    
    sIniTmp = GetIniString(App.Title, "DEBUG", "", sIniFile)
    If sIniTmp <> "" Then
        Me.Width = Me.Tag * 2
    Else
        Me.Width = Me.Tag
    End If
    
    Do_Log "Patchfile compatibility info: " & GetIniString(App.Title, "VER", "unknown", sIniFile)
                   
    Do_Log "Navigating to " & sIP
    WebBrowser1.Document.write "<p style=""color:#ccc;"">Please wait...</p>"
    WebBrowser1.Navigate2 CVar(sIP)
End Sub

Private Sub Read_Patch()
    Text1.Text = ""
    Text1.Text = Read_File(Combo1.List(Combo1.ListIndex))
End Sub

' for DEBUG mode
Private Sub Text1_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyF5 Then
        Read_Patch
    End If
End Sub

Private Function Read_File(sFilename As String) As String
    Dim sContent As String
    Dim iFileNum As Integer
    On Error GoTo Err_Trap
    iFileNum = FreeFile
    Open App.Path & "\" & sFilename For Input As #iFileNum
    sContent = Input(LOF(iFileNum), #iFileNum)
    On Error GoTo 0
Err_Trap:
    Close #iFileNum
    If sContent = "" Then
        Do_Log "File not found/empty: " & sFilename
    Else
        Do_Log "Read file: " & sFilename
    End If
    Read_File = sContent
End Function

Private Sub WebBrowser1_DocumentComplete(ByVal pDisp As Object, URL As Variant)
    If URL <> "about:blank" Then
        Do_Log "URL: " & URL

        ' W722V/W303V fix wild moveTo()/resizeTo() in hcti_start_passwort.stm frame
        If InStr(URL, "top_start_passwort.stm") > 0 Then
            WebBrowser1.Left = 0 ' bug, set to 0 first, then 8
            WebBrowser1.Left = 8
        End If
        
        Dim sLog As String
        Dim fNum As Long
        Dim i As Long
        For i = 1 To lMax
        
            ' look for URLs
            If sURLs(i) <> "" And InStr(URL, sURLs(i)) > 0 Then
                sLog = "URL-part " & sURLs(i) & " detected. Injecting "
    
                On Error Resume Next
                If sFrames(i) <> "" Then
                    fNum = Find_Frame(sFrames(i))
                    If fNum >= 0 Then
                        sLog = sLog & Inject_Code(WebBrowser1.Document.frames(fNum).Document)
                    Else
                        sLog = sLog & "nothing. Frame not found: " & sFrames(i)
                    End If
                Else
                    sLog = sLog & Inject_Code(WebBrowser1.Document)
                End If
    
                Do_Log sLog
            End If
    
        Next
    End If
End Sub

Private Function Inject_Code(ByRef doc As HTMLDocument) As String
    Dim sLog As String
    ' libs
    Dim j As Long
    For j = LBound(sLibraryContent) To UBound(sLibraryContent)
        If sLibraryContent(j) <> "" Then
            doc.parentWindow.execScript sLibraryContent(j), "JavaScript"
            sLog = sLog & sLibraryFiles(j) & ", "
        End If
    Next
    ' main patch
    doc.parentWindow.execScript Text1.Text, "JavaScript"
    sLog = sLog & "main patch."
    Inject_Code = sLog
End Function

Private Function Find_Frame(sName As String)
    Dim fNum As Long
    fNum = -1   ' default = not found
    If WebBrowser1.Document.frames.length > 0 Then
        ' try string
        Dim i As Long
        For i = 0 To WebBrowser1.Document.frames.length - 1
            If sName = WebBrowser1.Document.frames(i).Name Then
                fNum = i
                Exit For
            End If
        Next
        ' if no string found, try num (if num supplied)
        If fNum = -1 And IsNumeric(sName) = True Then
            If CLng(sName) < WebBrowser1.Document.frames.length Then
                fNum = CLng(sName)
            End If
        End If
    End If
    Find_Frame = fNum
End Function

Private Sub Form_Load()
    Me.Caption = App.Title & " " & App.Major & "." & App.Minor & "." & App.Revision
    
    Me.Tag = Me.Width  ' for DEBUG mode

    Populate_Combo1
    
    WebBrowser1.Navigate2 "about:blank"
    DoEvents
End Sub

Private Sub Do_Log(txt As Variant)
    Text2.Text = TimeValue(Now) & ": " & txt & vbCrLf & Text2.Text
End Sub

Private Sub Populate_Combo1()
    Combo1.Clear
    
    Dim file_name As String
    file_name = Dir(App.Title & "_*" & ".js")
    Do While file_name <> ""
        Call Combo1.AddItem(file_name)
        
        Do_Log "Patchfile found: " & file_name
        
        file_name = Dir
    Loop
    
    If Combo1.ListCount > 0 Then
        Combo1.ListIndex = 0
    End If
End Sub

' http://www.vbarchiv.net/workshop/workshop17.php
' Eintrag aus INI-Datei lesen
Public Function GetIniString(ByVal Sektion As String, _
  ByVal Titel As String, ByVal Vorgabe As String, _
  ByVal INIFile As String, _
  Optional ByVal nSize As Integer = 256) As String
 
  Dim lResult As Long
  Dim sValue As String
 
  sValue = Space$(nSize)
  lResult = GetPrivateProfileString(Sektion, Titel, _
    Vorgabe, sValue, nSize, INIFile)
  GetIniString = Left$(sValue, lResult)
End Function
