/*
[SPLivePatch]
IP=https://speedport.ip/
URL1=hcti_netzwerk_ddns.stm,hcti
URL2=hcti_start_passwort.stm,hcti
;URLx=filename[,(framename|framenum)]
LIBRARIES=jquery-1.7.2.min.js,jquery.cookie.js
;LIBRARIES=filename[,filename[,filename[,..]]]
VER=Speedport W303V Typ A, 1.06.000, 1.07.000, 1.09.000
*/
if (top.prodname && top.prodname == 'Speedport_W_303V_Typ_A') {
	if (window.location.href.indexOf('hcti_netzwerk_ddns.stm') != -1) {
		// add info-elements
		var _css ='z-index:2;width:180px;max-width:180px;margin-top:0px;margin-left:5px;padding-left:3px; position:absolute;visibility:hidden;';
		// attr() instead of inline attributes: http://bugs.jquery.com/ticket/11620
		$('<content47 />').attr({'id': 'content47', 'style': _css}).appendTo('#frameInfo');
		$('<content48 />').attr({'id': 'content48', 'style': _css}).appendTo('#frameInfo');
		$('#content47').html(_getHtml('content47'));
		$('#content48').html(_getHtml('content48'));
		// look for already selected in html-code from .stm
		var _defOld = -1;
		$('select[name=ddns_provider]').find('option').each(function(idx, elem) {
			if (elem.defaultSelected) _defOld = elem.value;
		});
		// create & add new option
		var _opt = $('<option />').attr('value', 4).text('Anderer Anbieter (SPLivePatch)');
		if (_defOld < 0) {
			_opt.attr('selected', 'selected');
		}
		_opt.appendTo('select[name=ddns_provider]');
		// clear undefined fields
		$('form[name=DDNS4] input[name=ddns_domainame], form[name=DDNS4] input[name=ddns_account], form[name=DDNS4] input[name=ddns_password], form[name=DDNS4] input[name=rddns_password]').val('');
		// patch div-content & event-handler of parent
		var _div = $('#um4 div').filter(function(idx) {
			return $(this).text() == 'URL:';
		});
		if (_div.length) {
			_div.text('DynDNS-Server:');
			_div.parent().unbind('mouseover').removeAttr('onmouseover').bind('mouseover', function(ev) { i_prfElem(48); });
		}
		// patch buggy event-handler & insert new row after
		var _div = $('#um4 div').filter(function(idx) {
			return $(this).text() == 'Kennwort wiederholen:';
		}).parent();
		if (_div.length) {
			_div.unbind('mouseover').removeAttr('onmouseover').bind('mouseover', function(ev) { i_prfElem(46); });
			// insert cookie-html
			$(_getHtml('ddns4_cookie')).insertAfter(_div);
		}
		// saved SPLivePatch cookie for DDNS4?
		var _ddns4Cookie = $.cookie('splp_w303v_ddns4');
		if (_ddns4Cookie) {
			var _arr = _ddns4Cookie.split('|');
			if (_arr.length == 4) {
				var _val = $('form[name=DDNS4] input[name=ddns_url]').val();
				if (_val == _arr[0] || _val == '') {
					$('form[name=DDNS4] input[name=ddns_url]').val(_arr[0]);
					$('form[name=DDNS4] input[name=ddns_account]').val(_arr[1]);
					$('form[name=DDNS4] input[name=ddns_domainame]').val(_arr[2]);
					$('form[name=DDNS4] input[name=ddns_password]').val(_arr[3]);
					$('form[name=DDNS4] input[name=rddns_password]').val(_arr[3]);
					$('#splp_ddns4_cookie').attr('checked', true);
				} else {
					_msg('Die gefundenen Cookiedaten fr "Anderer Anbieter" stimmen nicht mit dem bestehenden Feld "DynDNS-Server" berein und werden gelscht.');
					$.cookie('splp_w303v_ddns4', '', { expires: -1 });
				}
			} else {
				_msg('Die gefundenen Cookiedaten fr "Anderer Anbieter" sind ungltig und werden gelscht.');
				$.cookie('splp_w303v_ddns4', '', { expires: -1 });
			}
		}
		// notify user?
		if (_defOld < 0) {
			// if no default, the new option had probably been saved before
			stAkt();
			_msgDynDNS();
		} else if (ddns_url && ddns_url != '') {
			// default found, other option active, but ddns_url has a value
			_msgDynDNS();
		}
		// overwrite whole func
		function stDis(um) {
			$('select[name=ddns_provider], form[name=DDNS] input, form[name=DDNS1] input, form[name=DDNS2] input, form[name=DDNS3] input, form[name=DDNS4] input, #splp_ddns4_cookie').attr('disabled', um);
		}
		// patch existing func
		function stOKPatch_1() {
			// cookie handling for DDNS4
			if (document.tF.ddns_provider.value == 4) {
				if ($('#splp_ddns4_cookie').is(':checked')) {
					var _arr = [document.DDNS4.ddns_url.value, document.DDNS4.ddns_account.value, document.DDNS4.ddns_domainame.value, document.DDNS4.ddns_password.value];
					$.cookie('splp_w303v_ddns4', _arr.join('|'), { expires: 365 });
				} else {
					$.cookie('splp_w303v_ddns4', '', { expires: -1 });
				}
			}
		}
		var _stOKTmp = String(stOk);
		_stOKTmp = _stOKTmp.replace(
			'txtHinw("URL")',
			'txtHinw("DynDNS-Server")'
		);		
		_stOKTmp = _stOKTmp.replace(
			'document.tF.submit();',
			'stOKPatch_1();\n' +
			'document.tF.submit();'
		);	
		eval(_stOKTmp);
		// done.
	} else if (window.location.href.indexOf('hcti_start_passwort.stm') != -1) {
		$('<div style="position:absolute;top:125px;left:16px;padding:5px 8px;border:2px solid red;width:382px;"><b>SPLivePatch</b> aktiv, normal einloggen...</div>').appendTo('#frameEingabe');
	}
} else {
	_msg('Patch nicht aktiv, falsches Gert!');
}
function _getHtml(id) {
	var html;
	switch(id) {
		case 'content48':
			html = '' +
'<h2>Zugangsdaten fr Anderer Anbieter</h2><h4>DynDNS-Server</h4>' +
'<pf>Geben Sie den Hostnamen bzw. die Domain des DynDNS-Servers Ihres Anbieters ein, <b>ohne</b> <i>http://</i> und <b>ohne</b> <i>/nic/update</i> Parameter o..<br /><br />' +
'Es wird der Standard <a href="http://www.dyndns.com/developers/specs/syntax.html" target="_blank" style="text-decoration:underline;">DynDNS V2 von dyndns.org</a> benutzt.</pf>';
			break;
		case 'content47':
			html = '' +
'<h2>Zugangsdaten fr<br>Anderer Anbieter</h2><h4>In Cookie speichern</h4>' +
'<pf>Die Zugangsdaten fr "Anderer Anbieter" knnen per JavaScript bis auf den "DynDNS-Server" nicht aus dem Router ausgelesen werden. Sie mssen daher vor jedem "Speichern" neu eingegeben werden.<br><br>Als Alternative knnen die Zugangsdaten fr "Anderer Anbieter" wahlweise von <i>SPLivePatch</i> in einem Cookie im Browser gespeichert werden, allerdings unverschlsselt <b>im Klartext</b>.</pf>';
			break;
		case 'ddns4_cookie':
			html = '' +
'<DIV id=lineBtw></DIV>' +
'<DIV id=rowStd style="height:36px;" onmouseover="i_prfElem(47)" onmouseout="i_showElem(0)">' +
'	<DIV id=colStd style="height:36px;line-height:18px;">In Cookie speichern:<br>(im Klartext)</DIV>' +
'	<DIV id=colAbst></DIV>' +
'	<DIV id=colLast><input type="checkbox" id="splp_ddns4_cookie" value="1"></DIV>' +
'</DIV>';
			break;	
	}
	return html;
}
function _msgDynDNS() {
	if (!$('#splp_ddns4_cookie').is(':checked')) {
		_msg('Die Zugangsdaten fr "Anderer Anbieter" knnen per JavaScript bis auf den "DynDNS-Server" nicht aus dem Router ausgelesen werden. Sie mssen daher vor jedem "Speichern" neu eingegeben werden.\n\nAls Alternative knnen die Zugangsdaten fr "Anderer Anbieter" wahlweise von SPLivePatch in einem Cookie im Browser gespeichert werden, allerdings unverschlsselt im Klartext.');
	}
}
function _msg(txt) {
	setTimeout(function(){
		alert('SPLivePatch: ' + txt);
	}, 250);
}