/*
[SPLivePatch]
IP=http://speedport.ip/
URL1=hcti_netzwerk_ddns.stm,hcti
URL2=hcti_start_passwort.stm,hcti
URL3=hcti_status.stm,hcti
;URLx=filename[,(framename|framenum)]
LIBRARIES=jquery-1.7.2.min.js,jquery.cookie.js
;LIBRARIES=filename[,filename[,filename[,..]]]
VER=Speedport W700V, 3.33.000, 3.33.000-ddns-noip-selfhost
*/
if (window.location.href.indexOf('hcti_netzwerk_ddns.stm') != -1) {
	// look for 3.33.000 mod "fw-sp-w700v-ipone-b-3_33_000-ddns-noip-selfhost.bin"
	var _mod_dyndns_333000 = (String(chk).indexOf('var_ddns_provider') != -1) ? true : false;
	// add tabs
	var _css = 'top:161px;visibility:hidden;position:absolute;left:15px;width:402px;background-color:#F0F0F0;border:1px solid #E20074;border-top-style:none;';
	if (!_mod_dyndns_333000) {
		$('<div />').attr({'id': 'c_um3', 'style': _css}).html(_getHtml('c_um3')).appendTo('#c_Frame');
		$('<div />').attr({'id': 'c_um4', 'style': _css}).html(_getHtml('c_um4')).appendTo('#c_Frame');
		$('<div id="i_content10">' + _getHtml('i_content10') + '</div>').appendTo('#i_Frame');
	}
	$('<div />').attr({'id': 'c_um5', 'style': _css}).html(_getHtml('c_um5')).appendTo('#c_Frame');
	// add help-pages
	$('<div id="i_content49">' + _getHtml('i_content49') + '</div>').appendTo('#i_Frame');
	$('<div id="i_content43">' + _getHtml('i_content43') + '</div>').appendTo('#i_Frame');
	$('<div id="i_content44">' + _getHtml('i_content44') + '</div>').appendTo('#i_Frame');
	$('<div id="i_content45">' + _getHtml('i_content45') + '</div>').appendTo('#i_Frame');
	$('<div id="i_content46">' + _getHtml('i_content46') + '</div>').appendTo('#i_Frame');
	$('<div id="i_content47">' + _getHtml('i_content47') + '</div>').appendTo('#i_Frame');
	// add hidden for DDNS4
	$('<input name="ddns_url" type="hidden" />').appendTo('form[name=tF]');
	// saved SPLivePatch cookie for DDNS4?
	var _ddns4Cookie = $.cookie('splp_w700v_ddns4');
	if (_ddns4Cookie) {
		var _arr = _ddns4Cookie.split('|');
		if (_arr.length == 4) {
			var _val = $('form[name=DDNS4] input[name=ddns_url]').val();
			if (_val == _arr[0] || _val == '') {
				$('form[name=DDNS4] input[name=ddns_url]').val(_arr[0]);
				$('form[name=DDNS4] input[name=ddns_account]').val(_arr[1]);
				$('form[name=DDNS4] input[name=ddns_domainame]').val(_arr[2]);
				$('form[name=DDNS4] input[name=ddns_password]').val(_arr[3]);
				$('form[name=DDNS4] input[name=rddns_password]').val(_arr[3]);
				$('#splp_ddns4_cookie').attr('checked', true);
			} else {
				_msg('Die gefundenen Cookiedaten fr "Anderer Anbieter" stimmen nicht mit dem bestehenden Feld "DynDNS-Server" berein und werden gelscht.');
				$.cookie('splp_w700v_ddns4', '', { expires: -1 });
			}
		} else {
			_msg('Die gefundenen Cookiedaten fr "Anderer Anbieter" sind ungltig und werden gelscht.');
			$.cookie('splp_w700v_ddns4', '', { expires: -1 });
		}
	}
	// look for already selected in html-code from .stm
	var _defOld = -1;
	var _defNew = -1;
	$('select[name=ddns_provider]').find('option').each(function(idx, elem) {
		if (elem.defaultSelected) _defOld = elem.value;
	});
	// select via SPLivePatch <select> cookie?
	var _defCookie = false;
	if (_defOld < 0) {
		_defCookie = $.cookie('splp_w700v_ddns_provider');
		if (_defCookie) {
			_defOld = _defCookie;
			_defNew = _defCookie;
		}
	}
	// create new opt(s)
	var _opts = {};
	if (!_mod_dyndns_333000) {
		_opts[1] = 'No-IP.com';
		_opts[3] = 'selfhost.de';
		if (_defOld < 0) _defNew = 1;	// 'no cookies' fallback
	}
	_opts[4] = 'Anderer Anbieter';
	if (_defOld < 0 && _mod_dyndns_333000) _defNew = 4;	// 'no cookies' fallback
	// add new opt(s)
	$.each(_opts, function(val, txt) {
		var _opt = $('<option />').attr('value', val).text(txt + ' (SPLivePatch)');
		if (val == _defNew) {
			_opt.attr('selected', 'selected');
		}
		_opt.appendTo('select[name=ddns_provider]');
	});
	// notify user?
	if (_defOld < 0) {
		stAkt();
		if (!_mod_dyndns_333000 && !_defCookie) {
			_msg('Der zuletzt gewhlte Anbieter war "No-IP.com", "selfhost.de" oder "Anderer Anbieter", vor dem "Speichern" den richtigen Anbieter manuell auswhlen.');
		}
		// no default, does ddns_url have a value?
		if (ddns_url && ddns_url != '') {
			_msgDynDNS();
		}
	} else if (ddns_url && ddns_url != '') {
		// default found, other option active, but ddns_url has a value
		_msgDynDNS();
	}
	// overwrite whole func
	function stAkt() {
		$('#c_um1, #c_um2, #c_um3, #c_um4, #c_um5').css('visibility', 'hidden');
		$('#c_um' + ($('select[name=ddns_provider]').prop('selectedIndex') + 1)).css('visibility', 'visible')
	}
	// overwrite whole func
	function stDis(um) {
		$('select, input[type=text], input[type=password]').css('background-color', (um == true) ? '#D4D0C8' : '#FFFFFF').attr('disabled', um);
		$('#splp_ddns4_cookie').attr('disabled', um);
	}
	// patch existing func
	function stOKPatch_1() {
		if (!_mod_dyndns_333000) {
			if (document.tF.ddns_provider.value == 1) {
				for (i = 0; i < document.DDNS2.elements.length; i++) {
					if (document.DDNS2.elements[i].value.length != 0) {
						if ((document.DDNS2.elements[i].type.indexOf("text", 0) != -1) || (document.DDNS2.elements[i].type.indexOf("password", 0) != -1)) {
							if (document.DDNS2.elements[i].disabled == false) {
								for (k = 0; k < document.DDNS2.elements[i].value.length; k++) {
									if ((document.DDNS2.elements[i].value.charCodeAt(k) > 256) || (document.DDNS2.elements[i].value.charCodeAt(k) < 31)) {
										alert('Der ' + document.DDNS2.elements[i].value + ' ist ungltig.');
										document.DDNS2.elements[i].value = "";
										document.DDNS2.elements[i].focus();
										return false;
									}
								}
							}
						}
					}
				}
				document.tF.ddns_account.value = document.DDNS2.ddns_account.value;
				document.tF.ddns_domainame.value = document.DDNS2.ddns_domainame.value;
				top.tzo_ddns_account = document.DDNS2.ddns_account.value;
				top.tzo_ddns_domainame = document.DDNS2.ddns_domainame.value;
				document.tF.ddns_password.value = document.DDNS2.ddns_password.value;
				document.tF.rddns_password.value = document.DDNS2.rddns_password.value;
			}
			if (document.tF.ddns_provider.value == 3) {
				for (i = 0; i < document.DDNS3.elements.length; i++) {
					if (document.DDNS3.elements[i].value.length != 0) {
						if ((document.DDNS3.elements[i].type.indexOf("text", 0) != -1) || (document.DDNS3.elements[i].type.indexOf("password", 0) != -1)) {
							if (document.DDNS3.elements[i].disabled == false) {
								for (k = 0; k < document.DDNS3.elements[i].value.length; k++) {
									if ((document.DDNS3.elements[i].value.charCodeAt(k) > 256) || (document.DDNS3.elements[i].value.charCodeAt(k) < 31)) {
										alert('Der ' + document.DDNS3.elements[i].value + ' ist ungltig.');
										document.DDNS3.elements[i].value = "";
										document.DDNS3.elements[i].focus();
										return false;
									}
								}
							}
						}
					}
				}
				document.tF.ddns_account.value = document.DDNS3.ddns_account.value;
				document.tF.ddns_domainame.value = document.DDNS3.ddns_domainame.value;
				top.tzo_ddns_account = document.DDNS3.ddns_account.value;
				top.tzo_ddns_domainame = document.DDNS3.ddns_domainame.value;
				document.tF.ddns_password.value = document.DDNS3.ddns_password.value;
				document.tF.rddns_password.value = document.DDNS3.rddns_password.value;
			}
		}
		if (document.tF.ddns_provider.value == 4) {
			for (i = 0; i < document.DDNS4.elements.length; i++) {
				if (document.DDNS4.elements[i].value.length != 0) {
					if ((document.DDNS4.elements[i].type.indexOf("text", 0) != -1) || (document.DDNS4.elements[i].type.indexOf("password", 0) != -1)) {
						if (document.DDNS4.elements[i].disabled == false) {
							for (k = 0; k < document.DDNS4.elements[i].value.length; k++) {
								if ((document.DDNS4.elements[i].value.charCodeAt(k) > 256) || (document.DDNS4.elements[i].value.charCodeAt(k) < 31)) {
									alert('Der ' + document.DDNS4.elements[i].value + ' ist ungltig.');
									document.DDNS4.elements[i].value = "";
									document.DDNS4.elements[i].focus();
									return false;
								}
							}
						}
					}
				}
			}
			document.tF.ddns_url.value = document.DDNS4.ddns_url.value;
			document.tF.ddns_account.value = document.DDNS4.ddns_account.value;
			document.tF.ddns_domainame.value = document.DDNS4.ddns_domainame.value;
			top.tzo_ddns_account = document.DDNS4.ddns_account.value;
			top.tzo_ddns_domainame = document.DDNS4.ddns_domainame.value;
			document.tF.ddns_password.value = document.DDNS4.ddns_password.value;
			document.tF.rddns_password.value = document.DDNS4.rddns_password.value;
		}
		return true;
	}
	function stOKPatch_2() {
		if (!_mod_dyndns_333000) {
			if (document.F1.ddns_provider.selectedIndex == 2) {
				if (document.DDNS2.ddns_domainame.value == "" || isNSrv(document.DDNS2.ddns_domainame.value)) {
					alert(txtHinw("Host"));
					document.DDNS2.ddns_domainame.focus();
					return false;
				}
				if (document.DDNS2.ddns_account.value == "") {
					alert(txtHinw("Benutzername"));
					document.DDNS2.ddns_account.focus();
					return false;
				}
				if (document.DDNS2.ddns_password.value == "" || document.DDNS2.rddns_password.value == "" || document.DDNS2.ddns_password.value != document.DDNS2.rddns_password.value) {
					alert(txtHinw("Passwort' oder 'Passwort wiederholen"));
					document.DDNS2.ddns_password.value = "";
					document.DDNS2.rddns_password.value = "";
					document.DDNS2.ddns_password.focus();
					return false;
				}
			}
			if (document.F1.ddns_provider.selectedIndex == 3) {
				if (document.DDNS3.ddns_domainame.value == "" || isNSrv(document.DDNS3.ddns_domainame.value)) {
					alert(txtHinw("Hostname"));
					document.DDNS3.ddns_domainame.focus();
					return false;
				}
				if (document.DDNS3.ddns_account.value == "") {
					alert(txtHinw("User/Account"));
					document.DDNS3.ddns_account.focus();
					return false;
				}
				if (document.DDNS3.ddns_password.value == "" || document.DDNS3.rddns_password.value == "" || document.DDNS3.ddns_password.value != document.DDNS3.rddns_password.value) {
					alert(txtHinw("Passwort' oder 'Passwort wiederholen"));
					document.DDNS3.ddns_password.value = "";
					document.DDNS3.rddns_password.value = "";
					document.DDNS3.ddns_password.focus();
					return false;
				}
			}
		}
		if (document.F1.ddns_provider.selectedIndex == 4) {
			if (document.DDNS4.ddns_url.value == "" || isNSrv(document.DDNS4.ddns_url.value) || document.DDNS4.ddns_url.value.indexOf('/') != -1) {
				alert(txtHinw("DynDNS-Server"));
				document.DDNS4.ddns_domainame.focus();
				return false;
			}
			if (document.DDNS4.ddns_domainame.value == "" || isNSrv(document.DDNS4.ddns_domainame.value)) {
				alert(txtHinw("Domnenname"));
				document.DDNS4.ddns_domainame.focus();
				return false;
			}
			if (document.DDNS4.ddns_account.value == "") {
				alert(txtHinw("Benutzername"));
				document.DDNS4.ddns_account.focus();
				return false;
			}
			if (document.DDNS4.ddns_password.value == "" || document.DDNS4.rddns_password.value == "" || document.DDNS4.ddns_password.value != document.DDNS4.rddns_password.value) {
				alert(txtHinw("Passwort' oder 'Passwort wiederholen"));
				document.DDNS4.ddns_password.value = "";
				document.DDNS4.rddns_password.value = "";
				document.DDNS4.ddns_password.focus();
				return false;
			}
		}
		return true;
	}
	function stOKPatch_3() {
		$('#c_um1, #c_um2, #c_um3, #c_um4, #c_um5').css('visibility', 'hidden');
		// cookie handling for <select>
		var _defNew = document.tF.ddns_provider.value;
		if (_defNew != 0 && _defNew != 2) {
			$.cookie('splp_w700v_ddns_provider', _defNew, { expires: 365 });
		} else {
			$.cookie('splp_w700v_ddns_provider', '', { expires: -1 })
		}
		// cookie handling for DDNS4
		if (_defNew == 4) {
			if ($('#splp_ddns4_cookie').is(':checked')) {
				var _arr = [document.DDNS4.ddns_url.value, document.DDNS4.ddns_account.value, document.DDNS4.ddns_domainame.value, document.DDNS4.ddns_password.value];
				$.cookie('splp_w700v_ddns4', _arr.join('|'), { expires: 365 });
			} else {
				$.cookie('splp_w700v_ddns4', '', { expires: -1 });
			}
		}
	}
	var _stOKTmp = String(stOk);
	_stOKTmp = _stOKTmp.replace(
		'if (document.tF.ddns_provider.value==2)',
		'if (!stOKPatch_1()) return false;\n' +
		'if (document.tF.ddns_provider.value==2)'
	);
	_stOKTmp = _stOKTmp.replace(
		'else{\r\n\t\tif (document.DDNS1.ddns_domainame.value==""',
		'if (!stOKPatch_2()) return false;\n' +
		'if (document.F1.ddns_provider.selectedIndex==1){\r\n\t\tif (document.DDNS1.ddns_domainame.value==""'
	);
	_stOKTmp = _stOKTmp.replace(
		'document.tF.submit();',
		'stOKPatch_3();\n' +
		'document.tF.submit();'
	);	
	eval(_stOKTmp);
	// done.
} else if (window.location.href.indexOf('hcti_status.stm') != -1) {
	$(_getHtml('hidden_status')).insertBefore('#c_linklast');

} else if (window.location.href.indexOf('hcti_start_passwort.stm') != -1) {
	$('<div style="position:absolute;top:155px;left:15px;padding:5px 8px;border:2px solid red;width:402px;"><b>SPLivePatch</b> aktiv, normal einloggen...</div>').appendTo('#c_Frame');
}
function _getHtml(id) {
	var html;
	switch(id) {
		// based on 3.33.000 mod "fw-sp-w700v-ipone-b-3_33_000-ddns-noip-selfhost.bin"
		case 'c_um3':
			html = '' +
'<DIV id=c_titel>Zugangsdaten fr No-IP.com (SPLivePatch)</DIV>' +
'<DIV id=c_std>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(3) onmouseout=i_showElem(0)>' +
'	    <form name="DDNS2">' +
'			<td width="140">Host:</td>' +
'			<td><input type="text" name="ddns_domainame" size="28" maxlength="49" value="'+ddns_domain[1]+'"></td>' +
'		</tr>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_std>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(4) onmouseout=i_showElem(0)>' +
'			<td width="140">Benutzername:</td>' +
'			<td><input type="text" name="ddns_account" size="28" maxlength="49" value="'+ddns_account[1]+'"></td>' +
'		</tr>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_std>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(5) onmouseout=i_showElem(0)>' +
'			<td width="140">Passwort:</td>' +
'			<td><input type="password" class="stylepwd" name="ddns_password" size="20" maxlength="49" value="'+ddns_password[1]+'"></td>' +
'	    </tr>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_last>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(5) onmouseout=i_showElem(0)>' +
'			<td width="140">Passwort wiederholen:</td>' +
'			<td><input type="password" class="stylepwd" name="rddns_password" size="20" maxlength="49" value="'+ddns_password[1]+'"></td>' +
'	    </tr>' +
'		</form>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_leer></DIV>' +
'<DIV id=c_foot></DIV>';
			break;
		case 'c_um4':
			html = '' +
'<DIV id=c_titel>Zugangsdaten fr selfhost.de (SPLivePatch)</DIV>' +
'<DIV id=c_std>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(3) onmouseout=i_showElem(0)>' +
'	    <form name="DDNS3">' +
'			<td width="140">Hostname:</td>' +
'			<td><input type="text" name="ddns_domainame" size="28" maxlength="49" value="'+ddns_domain[3]+'"></td>' +
'		</tr>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_std>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(10) onmouseout=i_showElem(0)>' +
'			<td width="140">User/Account:</td>' +
'			<td><input type="text" name="ddns_account" size="28" maxlength="49" value="'+ddns_account[3]+'"></td>' +
'		</tr>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_std>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(5) onmouseout=i_showElem(0)>' +
'			<td width="140">Passwort:</td>' +
'			<td><input type="password" class="stylepwd" name="ddns_password" size="20" maxlength="49" value="'+ddns_password[3]+'"></td>' +
'	    </tr>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_last>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(5) onmouseout=i_showElem(0)>' +
'			<td width="140">Passwort wiederholen:</td>' +
'			<td><input type="password" class="stylepwd" name="rddns_password" size="20" maxlength="49" value="'+ddns_password[3]+'"></td>' +
'	    </tr>' +
'		</form>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_leer></DIV>' +
'<DIV id=c_foot></DIV>';
			break;
		case 'c_um5':
			html = '' +
'<DIV id=c_titel>Zugangsdaten fr Anderer Anbieter (SPLivePatch)</DIV>' +
'<DIV id=c_std>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(49) onmouseout=i_showElem(0)>' +
'	    <form name="DDNS4">' +
'			<td width="140">DynDNS-Server:</td>' +
'			<td><input type="text" name="ddns_url" size="28" maxlength="49" value="'+ddns_url+'"></td>' +
'		</tr>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_std>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(43) onmouseout=i_showElem(0)>' +
'			<td width="140">Domnenname:</td>' +
'			<td><input type="text" name="ddns_domainame" size="28" maxlength="49" value=""></td>' +
'		</tr>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_std>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(44) onmouseout=i_showElem(0)>' +
'			<td width="140">Benutzername:</td>' +
'			<td><input type="text" name="ddns_account" size="28" maxlength="49" value=""></td>' +
'		</tr>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_std>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(45) onmouseout=i_showElem(0)>' +
'			<td width="140">Passwort:</td>' +
'			<td><input type="password" class="stylepwd" name="ddns_password" size="20" maxlength="49" value=""></td>' +
'	    </tr>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_std>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(46) onmouseout=i_showElem(0)>' +
'			<td width="140">Passwort wiederholen:</td>' +
'			<td><input type="password" class="stylepwd" name="rddns_password" size="20" maxlength="49" value=""></td>' +
'	    </tr>' +
'		</form>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_last>' +
'	<table border="0" cellpadding="0" cellspacing="2">' +
'		<tr onmouseover=i_prfElem(47) onmouseout=i_showElem(0)>' +
'			<td width="140">In Cookie speichern:<br>(im Klartext)</td>' +
'			<td><input type="checkbox" id="splp_ddns4_cookie" value="1"></td>' +
'	    </tr>' +
'		</form>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_leer></DIV>' +
'<DIV id=c_foot></DIV>';
			break;
		case 'i_content10':
			html = '' +
'<h2>Zugangsdaten</h2><p><b>Benutzername</b><br>' +
'Geben Sie hier Ihren ID (User/Account) ein, den Sie von selfhost.de unter "dyn Accounte / Details" erhalten.</p>';
			break;
		case 'i_content49':
			html = '' +
'<h2>Zugangsdaten fr<br>Anderer Anbieter</h2>' +
'<p><b>DynDNS-Server</b><br>' +
'Geben Sie hier den Hostnamen bzw. die Domain des DynDNS-Servers Ihres Anbieters ein, <b>ohne</b> <i>http://</i> und <b>ohne</b> <i>/nic/update</i> Parameter o..</p>' +
'<p>Es wird der Standard <a href="http://www.dyndns.com/developers/specs/syntax.html" target="_blank" style="text-decoration:underline;">DynDNS V2 von dyndns.org</a> benutzt.</p>';
			break;
		// 43-46 based on W722V hidden entry
		case 'i_content43':
			html = '' +
'<h2>Zugangsdaten fr<br>Anderer Anbieter</h2><p><b>Domnenname</b><br>' +
'Geben Sie hier Ihren Domnennamen ein, den Sie bei Ihrem Anbieter bei der Anmeldung registriert haben.</p>';
			break;
		case 'i_content44':
			html = '' +
'<h2>Zugangsdaten fr<br>Anderer Anbieter</h2><p><b>Benutzername</b><br>' +
'Geben Sie hier Ihren Benutzernamen ein, den Sie von Ihrem Anbieter bei der Anmeldung erhalten haben.</p>';
			break;
		case 'i_content45':
			html = '' +
'<h2>Zugangsdaten fr<br>Anderer Anbieter</h2><p><b>Kennwort</b><br>' +
'Geben Sie hier Ihr Kennwort ein, das Sie von Ihrem Anbieter bei der Anmeldung erhalten haben.</p>';
			break;
		case 'i_content46':
			html = '' +
'<h2>Zugangsdaten fr<br>Anderer Anbieter</h2><p><b>Kennwort wiederholen</b><br>' +
'Wiederholen Sie hier zur Sicherheit Ihr Kennwort.</p>';
			break;
		case 'i_content47':
			html = '' +
'<h2>Zugangsdaten fr<br>Anderer Anbieter</h2><p><b>In Cookie speichern</b><br>' +
'Die Zugangsdaten fr "Anderer Anbieter" knnen per JavaScript bis auf den "DynDNS-Server" nicht aus dem Router ausgelesen werden. Sie mssen daher vor jedem "Speichern" neu eingegeben werden.</p><p>Als Alternative knnen die Zugangsdaten fr "Anderer Anbieter" wahlweise von <i>SPLivePatch</i> in einem Cookie im Browser gespeichert werden, allerdings unverschlsselt <b>im Klartext</b>.</p>';
			break;
		case 'hidden_status':
			html = '' +
'<DIV id=c_link>' +
'	<table border="0" cellpadding="4" cellspacing="0">' +
'		<tr><td width="200"><a href="adsl_status.stm" target="hcti"><b>&gt;&gt; </b>ADSL Status Information</a></td><td>(SPLivePatch)</td></tr>' +
'	</table>' +
'</DIV>' +
'<DIV id=c_link>' +
'	<table border="0" cellpadding="4" cellspacing="0">' +
'		<tr><td width="200"><a href="mac_test.stm" target="hcti"><b>&gt;&gt; </b>MAC address Pool</a></td><td>(SPLivePatch)</td></tr>' +
'	</table>' +
'</DIV>';
			break;
	}
	return html;
}
function _msgDynDNS() {
	if (!$('#splp_ddns4_cookie').is(':checked')) {
		_msg('Die Zugangsdaten fr "Anderer Anbieter" knnen per JavaScript bis auf den "DynDNS-Server" nicht aus dem Router ausgelesen werden. Sie mssen daher vor jedem "Speichern" neu eingegeben werden.\n\nAls Alternative knnen die Zugangsdaten fr "Anderer Anbieter" wahlweise von SPLivePatch in einem Cookie im Browser gespeichert werden, allerdings unverschlsselt im Klartext.');
	}
}
function _msg(txt) {
	setTimeout(function(){
		alert('SPLivePatch: ' + txt);
	}, 250);
}